/**
 * Created by ElasticAd. Version: 1.6.2
 
 * @change log
 * 1.0      - first version
 * 1.1      - adaugare nurl
 * 1.2      - adaugare assets expand, sponsor, vast_as_teaser
 * 1.3      - scoate obiectul din iframe pe window.document
 * 1.4      - clicktrackers img
 * 1.5      - modificare vast
 * 1.6      - adaugare criteo + quantx object
 * 1.6.1    - modificari la quantx criteo fillimages + adomain
 * 1.6.2    - adaugare macros la trackere

 */

(function (window, document) {

    //general variables
    var win = window;
    var doc = document;

    /*if (isInIframe()) {
        win = window.parent;
        doc = window.parent.document;
    }*/

    while (isInIframe(win)) {
        win = win.parent;
        doc = win.document;
    }

    win.ean.sspiponwebInit = function (eanExternAd) {
        //console.log(eanExternAd);
        var getScriptSRC = function (link, doc) {
            switch (link.substring(0, 2)) {
                case '//':
                    return doc.location.protocol + link;
                case 'ht':
                    if (link.substring(0, 5) === 'https') {
                        return doc.location.protocol + link.substring(6);
                    } else {
                        return doc.location.protocol + link.substring(5);
                    }
                default:
                    return doc.location.protocol + '//' + link;
            }
        };

        var loadDefaultPlacement = function () {
            if (win.ean && win.ean.placementsByAPXID[eanExternAd.adnxsId]) {
                var placement = win.ean.placementsByAPXID[eanExternAd.adnxsId];
                placement.template.placement_params = placement.template.placement_params ? placement.template.placement_params : {};
                placement.template.placement_params.sspIponWeb_init = false;
                win.ean.placementsByAPXID[eanExternAd.adnxsId].ttjParsed = false;
                win.ean.initPlacement([placement]);
            }
        };

        var loadFallback = function(content) {
            var placementData = win.ean.placementsByAPXID [eanExternAd.adnxsId];

            var selector = placementData.template.selector;
            if (win.ean.utils.isArray(selector)) {
                selector = selector[0];
            }
            var method = placementData.template.method || placementData.method;
            if (win.ean.utils.isArray(method)) {
                method = method[0];
            }
            var htmlSettings = {};
            htmlSettings.tags = {};

            content = win.ean.utils.parseContent(content);
            win.ean.utils.replaceHtml(content, htmlSettings, selector, method, placementData, placementData.template);

            var scripts = win.document.querySelectorAll("[data-eascript=true]");
            win.ean.parseScripts(scripts);
        }

        if (!win.ean.sspIponWebReload) {
            win.ean.sspIponWebReload = [];
        }
        if (win.ean.sspIponWebReload[eanExternAd.adnxsId] === undefined) {
            win.ean.sspIponWebReload[eanExternAd.adnxsId] = 2;
        }

        eanExternAd.dspData = JSON.parse(eanExternAd.dspData);
        if(eanExternAd.dspData.nativeTag && eanExternAd.dspData.iponwebAdUnitId) {
            eanExternAd.adUrl = eanExternAd.dspData.nativeTag+eanExternAd.dspData.iponwebAdUnitId;
             //var scriptRequest = getScriptSRC(eanExternAd.adUrl, doc);
        } else {
            loadDefaultPlacement();
        }


        var criteoAd = function(response) {
            var ad = {};
            var cObj = null;

            if(!response['cobj']) {
                return false;
            }

            cObj = response['cobj'];

            var link = cObj.link;

            var trackers = [];

            var jstracker = '';
            if(cObj.jstracker) {
                jstracker = cObj.jstracker;
            }

            if(cObj.imptrackers) {
                trackers = cObj.imptrackers;
            }

            var sync_pixels = [];
            if (response.sync) {
                sync_pixels = response.sync;
            }

            if(response.nurl) {
                trackers.push(response.nurl);
            }

            if(cObj.view_notice_tracker) {
                trackers.push(cObj.view_notice_tracker);
            }

            ad['title'] = ad['main_image'] = ad['content'] = ad['sponsor_logo'] = ad['sponsor_name']
                = ad['sponsor_url'] = ad['expanded_summary'] = ad['full_text'] = ad['autoexpand_content_type']
                = ad['teaser_type'] = ad['video_url'] = '';

            ad['content_type'] = 'content_link';
            ad['expanded_content_type'] = 'none';

            if(cObj['image_url']) {
                ad['main_image'] = cObj['image_url'];
            }

            if(cObj['title']) {
                ad['title'] = cObj['title'];
            }

            if(cObj['description']) {
                ad['content'] = cObj['description'];
            }

            if(cObj.adomain && cObj.adomain) {
                ad['sponsor_name'] =  cObj.adomain;
                ad['sponsor_url'] =  '//'+cObj.adomain;
            }

            var action_url = cObj.click_url;

            if (!ad['sponsor_url']) {
                ad['sponsor_url'] = action_url;
            }

            win.ean.dspLoadExtras[eanExternAd.ah] = function (placementHTML) {
                placementHTML = placementHTML.querySelector('.ead_adchoice') ? placementHTML.querySelector('.ead_adchoice') : placementHTML;
                var criteoAdChoice = win.document.createElement("a");
                if (placementHTML.style.position == "") {
                    placementHTML.style.position = 'relative';
                }

                criteoAdChoice.href = cObj.privacy.click_url;
                criteoAdChoice.target = "_blank";
                criteoAdChoice.style.display = "block";
                criteoAdChoice.style.position = "absolute";
                criteoAdChoice.style.top = "5px";
                criteoAdChoice.style.right = "5px";
                criteoAdChoice.style.margin = "0px";
                criteoAdChoice.style.padding = "0px";
                criteoAdChoice.style.border = "none";
                criteoAdChoice.style.height = "auto";
                criteoAdChoice.style.width = "auto";
                criteoAdChoice.style.zIndex = "9999";
                criteoAdChoice.innerHTML = '<img src="' + cObj.privacy.image_url + '" style="width:19px; height:15px;">';
                // + impression_pixels;
                placementHTML.appendChild(criteoAdChoice);
            };

            eanExternAd.dspData.criteoAd = cObj;

            var eanExternAdSettings = {
                settings: {
                    ah:  eanExternAd.ah,
                    sharer_domain: null,
                    click_trackers_images: link.clicktrackers,
                    quantx: eanExternAd.dspData,
                    tags: {
                        autoexpand_content_type: ad['autoexpand_content_type'],//aici se poate trimite din iw un alt tag in care se poate spune cum se face autoexpand ex: 'hover'
                        brand_logo: ad['sponsor_logo'],
                        brand_name: ad['sponsor_name'],
                        brand_url: ad['sponsor_url'],
                        content_link: action_url,
                        content_type: ad['content_type'],
                        expanded_content_type: ad['expanded_content_type'],
                        expanded_summary: ad['expanded_summary'],
                        image_landscape: ad['main_image'],
                        image_large_landscape: ad['main_image'],
                        image_portrait: ad['main_image'],
                        image_square: ad['main_image'],
                        overlay_content: "",
                        overlay_content_type: "embed",
                        summary: ad['content'],
                        teaser_type: ad['teaser_type'],
                        title: ad['title'],
                        video_url: ad['video_url'],
                        full_text: ad['full_text']
                    },
                    type: "native"
                }
            };
            win.ean.isIntegrationDSP[eanExternAd.ah] = true;
            win.ean.show(eanExternAdSettings);

            //trackers
            for (var i in trackers) {
                if (trackers[i]) {
                    var img = win.document.createElement("img");
                    img.src = trackers[i];
                    img.style.display = "none";
                    win.document.getElementsByTagName("body")[0].appendChild(img);
                }
            }

            if(jstracker) {
                var regex = /<script[^>]*>([\s\S]+?)<\/script>/gi;
                var match = regex.exec(jstracker);
                if(match.length > 0) {
                    var jsVar = match[1];
                    jsVar = jsVar.replace('var js_tracker = [\'','').replace('\']','');
                    var scripts = jsVar.split("', '");
                    if(scripts.length > 0) {
                        win.ean.console.log('scripts',scripts);
                        while (scripts && scripts.length>0) {
                            win.ean.utils.loadScript(decodeURIComponent(scripts.shift()));
                        }
                    }
                }
            }

            for (var i in sync_pixels) {
                if (sync_pixels[i]) {
                    var img = win.document.createElement("img");
                    img.src = sync_pixels[i];
                    img.style.display = "none";
                    win.document.getElementsByTagName("body")[0].appendChild(img);
                }
            }
        }

        var error = function (responseObject, status) {
            loadDefaultPlacement();
        };

        //!!!!!! IWNativeInit in caz ca se modifica ceva aici se modifica si in functia specificata in wrapper
        var success = function (responseObject, sspIponWebAdSettings) {
            response = JSON.parse(sspIponWebAdSettings);

            var ad = {};

            if(response['is_fallback']) {
                if(response['adm']) {
                    loadFallback(response['adm']);
                }
                //console.log("IS FALLBACK!!!");
            }

            //daca este criteoad va fi afisat de aici
            criteoAd(response);

            if(!response['native']) {
                return false;
            }

            var openRTBAD = response['native'];
            var assets = openRTBAD.assets;
            var link = openRTBAD.link;

            var trackers = [];
            if(openRTBAD.imptrackers) {
                trackers = openRTBAD.imptrackers;
            }

            var jstracker = '';
            if(openRTBAD.jstracker) {
                jstracker = openRTBAD.jstracker;
            }

            if(response.nurl) {
                trackers.push(response.nurl);
            }

            var sync_pixels = [];
            if (response.sync) {
                sync_pixels = response.sync;
            }

            ad['title'] = ad['main_image'] = ad['content'] = ad['sponsor_logo'] = ad['sponsor_name']
                = ad['sponsor_url'] = ad['expanded_summary'] = ad['full_text'] = ad['autoexpand_content_type']
                = ad['teaser_type'] = ad['video_url'] = '';

            ad['content_type'] = 'content_link';
            ad['expanded_content_type'] = 'none';

            for(var i=0;i<assets.length;i++) {
                //console.log(assets[i]);
                var asset = assets[i];
                switch(asset['id']) {
                    case 1:
                        ad['title'] = asset['title']['text'];
                        break;
                    case 2:
                        ad['sponsor_logo'] = asset['img']['url'];
                        break;
                    case 3:
                        ad['content'] = asset['data']['value'];
                        break;
                    case 4:
                        ad['main_image'] = asset['img']['url'];
                        break;
                    case 6: //teaser as vast
                        ad['teaser_type']   = 'vast';
                        ad['video_url']     = asset['video']['vasttag'];
                        break;
                    case 10:
                        ad['sponsor_name'] = asset['data']['value'];
                        break;
                    case 2001:
                        ad['expanded_content_type'] = 'embed';
                        ad['expanded_summary'] = asset['data']['value'];
                        break;
                    case 2002:
                        ad['expanded_content_type'] = 'vast';
                        ad['expanded_summary'] = asset['data']['value'];
                        break;
                    case 2003:
                        ad['sponsor_url'] = asset['data']['value'];
                        break;
                    case 2004: //prism
                        ad['content_type'] = 'prism';
                        break;
                    case 2005: //internal_landing_page
                        ad['content_type'] = 'internal_landing_page';
                        ad['internal_content_link'] = asset['data']['value'];
                        break;
                    case 2006: //teaser as vast
                        ad['teaser_type'] = 'vast';
                        ad['video_url'] = asset['data']['value'];
                        break;
                    case 2007:
                        ad['autoexpand_content_type'] = asset['data']['value'];
                        break;
                    case 2022: //content page
                        ad['content_type'] = 'full_text';
                        ad['full_text'] =  asset['data']['value'];
                        break;
                }
            }

            var action_url = link.url;

            if (!ad['sponsor_url']) {
                ad['sponsor_url'] = action_url;
            }

            var eanExternAdSettings = {
                settings: {
                    ah: eanExternAd.ah,
                    sharer_domain: null,
                    //click_trackers: link.clicktrackers,
                    click_trackers_images: link.clicktrackers,
                    quantx: eanExternAd.dspData,
                    tags: {
                        autoexpand_content_type: ad['autoexpand_content_type'],//aici se poate trimite din iw un alt tag in care se poate spune cum se face autoexpand ex: 'hover'
                        brand_logo: ad['sponsor_logo'],
                        brand_name: ad['sponsor_name'],
                        brand_url: ad['sponsor_url'],
                        content_link: action_url,
                        content_type: ad['content_type'],
                        expanded_content_type: ad['expanded_content_type'],
                        expanded_summary: ad['expanded_summary'],
                        image_landscape: ad['main_image'],
                        image_large_landscape: ad['main_image'],
                        image_portrait: ad['main_image'],
                        image_square: ad['main_image'],
                        overlay_content: "",
                        overlay_content_type: "embed",
                        summary: ad['content'],
                        teaser_type: ad['teaser_type'],
                        title: ad['title'],
                        video_url: ad['video_url'],
                        full_text: ad['full_text']
                    },
                    type: "native"
                }
            };
            win.ean.isIntegrationDSP[eanExternAd.ah] = true;
            win.ean.show(eanExternAdSettings);
            //console.log('Trackers:', trackers);
            for (var i in trackers) {
                if (trackers[i]) {
                    var img = win.document.createElement("img");
                    img.src = win.ean.utils.replaceCreativeMacros(trackers[i],eanExternAd);
                    img.style.display = "none";
                    win.document.getElementsByTagName("body")[0].appendChild(img);
                }
            }

            if(jstracker) {
                var regex = /<script[^>]*>([\s\S]+?)<\/script>/gi;
                var match = regex.exec(jstracker);
                if(match.length > 0) {
                    var jsVar = match[1];
                    jsVar = jsVar.replace('var js_tracker = [\'','').replace('\']','');
                    var scripts = jsVar.split("', '");
                    if(scripts.length > 0) {
                        //win.ean.console.log('scripts',scripts);
                        while (scripts && scripts.length>0) {
                            win.ean.utils.loadScript(win.ean.utils.replaceCreativeMacros(decodeURIComponent(scripts.shift()),eanExternAd));
                        }
                    }
                }
                //win.ean.console.log("JSTracker:",jsVar, jstracker, match);
            }

            for (var i in sync_pixels) {
                if (sync_pixels[i]) {
                    var img = win.document.createElement("img");
                    img.src = sync_pixels[i];
                    img.style.display = "none";
                    win.document.getElementsByTagName("body")[0].appendChild(img);
                }
            }

        };
        //load sspIponWeb
        win.ean.utils.ajaxLoad(eanExternAd.adUrl, success, error, null, true);
    };

    //check for iframe function
    function isInIframe(win) {
        if (win.ean && win.ean.show) return false;
        if (win.parent !== win) {
            try {
                var u = win.parent.location;
                var frm = win.frameElement;
                var doc = win.parent.document;
                if (doc === undefined)
                    return false;
                return  true;
            } catch (e) {
            }
        }
        return false;
    }

})(window, document);
